      program map
c
#include "comxyh.inc"
c
      parameter (jpobs=2000)
c
      integer ii(jpobs),iii(jpobs),lat(jpobs),lon(jpobs)
      real   pobs(jpobs),tobs(jpobs)
      integer pflag(jpobs),tflag(jpobs)
c
      parameter (jplon=300,jplat=300)
c
      real  x(jplon*jplat), y(jplon*jplat),
     x	   xp(jplon*jplat),yp(jplon*jplat),
     x	    p(jplon*jplat), t(jplon*jplat)
c
      character*1 lin(4*(jplon+2)*(jplat+2))
c
#include "comdef.inc"
c
      character*4  monname(12)
      character*9  dayname
      character*64 text
c
c------------------------------------------------------------------------------
c
c     selection of map characteristics.
c
      character*40 driver,device
      integer bgcol
      integer ifldthi,ifldcol
      integer ifrathi,ifracol
      integer icoathi,icoacol
      integer ilatthi,ilatcol
      integer ilabthi,ilabcol
      integer ilogthi,ilogcol
      logical lcoast,llatlon,llogo,lframe
      character*1 clbase
      real latmin,latmax,idlat,lonmin,lonmax,idlon
      real hgtlog
c
#include "comrep.inc"
c
      namelist/namgeo/ publication,
     +	      bgcol,driver,device,
     +	      llatlon,lcoast,llogo,lframe,
     +        ifldthi,ifldcol,
     +	      ifrathi,ifracol,icoathi,icoacol,ilatthi,ilatcol,
     +	      ilabthi,ilabcol,ilogthi,ilogcol,
     +	      ltotal,maprep,scale,hgtlog,
     +	      prolat,prolon,latmid,lonmid,dxmap,dymap,
     +        xorigo,yorigo,
     +	      latmin,latmax,idlat,lonmin,lonmax,idlon,
     +	      clbase
c
c
      integer year,month,day,hour
      character*3 expnam
      real hgttxt,obssize,disop,disot
      logical tplot,pplot
      namelist/namexp/year,month,day,hour,expnam,hgttxt,obssize,
     x		      disop,disot,pplot,tplot
c
      character*12 filnam
      character*11 varnam
c
c-----------------------------------------------------------------------------
c
c    defaults for namelist input
c
c   namgeo:
c   --------------------
      data publication/.false./
      data xorigo/2./,yorigo/5./
      data llatlon/.false./,lcoast/.false./,llogo/.true./,lframe/.true./
      data ifldthi/20/,ifldcol/27/
      data icoathi/3/,ifrathi/50/,ilabthi/2/,ilatthi/1/
      data icoacol/5/,ifracol/6/,ilabcol/7/,ilatcol/8/
      data ilogthi/2/,ilogcol/9/,hgtlog/1.00/
      data latmin/ 30./,latmax/75./,idlat/15./
      data lonmin/-90./,lonmax/90./,idlon/15./
      data prolat/60./,latmid/90/,lonmid/00/,dxmap/24./,dymap/18./
      data prolon/0./
      data clbase /'g'/
      data bgcol /0/
      data obssize /0.3/
      data hgttxt /0.3/
      data disop /2./
      data disot /2./
      data pplot /.false./
      data tplot /.true./
c
c-----------------------------------------------------------------------------
c
c     other defaults:
c
c
      data monname/' jan',' feb',' mar',' apr',' may',' jun',
     +             ' jul',' aug',' sep',' oct',' nov',' dec'/
c
c

      open(unit=55,file='namgeo.dat')
      read(55,namgeo)
      write(6,namgeo)
      close(unit=55)
      open(unit=55,file='namexp.dat')
      read(55,namexp)
c     write(6,namexp)
      close(unit=55)
c
      iy=year-year/100*100
      write(filnam,'(i2.2,i2.2,i2.2,i2.2,a1,a3)')
     x			  iy,month,day,hour,'.',expnam
      lunin = 10
      open(unit=lunin,file=filnam)
      read(lunin,*)nlon,nlat,alats,alonw,dtheta,dlamda
      npoint=nlon*nlat
      read(lunin,'(a)') text
      write(6,*) 'read :',text
      read(lunin,*)(p(k),k=1,npoint)
      read(lunin,'(a)') text
      write(6,*) 'read :',text
      read(lunin,*)(t(k),k=1,npoint)
      do 120 k=1,npoint
      t(k) = t(k) - 273.2
  120 continue
      nobs=0
      read(lunin,'(a)') text
      write(6,*) 'read :',text
  150 read(lunin,*,end=200)ii(nobs+1),iii(nobs+1),
     x		   lat(nobs+1),lon(nobs+1),
     x		   pobs(nobs+1),tobs(nobs+1),pflag(nobs+1),
     x		   tflag(nobs+1)
      nobs=nobs+1
      goto 150
  200 continue
      close(unit=lunin)
c
      irep=00
      alatn=alats+(nlat-1)*dtheta
      alone=alonw+(nlon-1)*dlamda
      alatsp=-90.
      alonsp=0.
c
c
c     1.2  set date and time.
c	   ------------------
c
      if( year.gt.0 .and. year.lt.100 )then
	 year = year + 1900
      endif
c
c     1.3  write time label string.
c	    ------------------------
c
      call weekday(year,month,day,dayname,lholy)
c
c     4.1  set up the geometry.
c	    ---------------------
c
      nona=nlon*nlat
      call xyplot(nona,x,y,xmin,xmax,ymin,ymax)
      call iniobs(xmin,xmax,ymin,ymax)

      do 300 k=1,nona
      x(k) = x(k) + xorigo
      y(k) = y(k) + yorigo
  300 continue
c
      xmin = xmin + xorigo
      xmax = xmax + xorigo
      ymin = ymin + yorigo
      ymax = ymax + yorigo
c
      call plotex('POST',.true.)

c/PD         pplot=.false.
c/PD         tplot=.true.

         if(tplot)then
            varnam='Temperature'
         elseif(pplot)then
            varnam='Pressure'
         endif
            
c
      do j=1,64
         text(j:j)=' '
      enddo    
      write(text(1:49),
     +	       '(a11,a10,a9,i3,a4,i5,1x,i2.2,a4)') varnam,
     +	 ' analysis ',dayname,day,monname(month),year,hour,' utc'
c
      call newpex(ilabthi,ilabcol)
      call symbex(xorigo+0.25,yorigo-1.0,0.25,text,0.,64)
c
c----------------------------------------------------------------------------
c
c     coastlines
      if(lcoast)then
      call newpex(icoathi,icoacol)
      ltypec = 1
      write(6,*) 'call coast'
      call coast(xp,yp,ltypec,xmin,xmax,ymin,ymax,xorigo,yorigo,
     x           clbase)
      write(6,*) 'done coast'
      endif

c     latitudes and longitudes. latitude +-90 singular, not possible.
      if(llatlon)then
         if(latmin.lt.-85.)latmin=-85.
         if(latmax.gt. 85.)latmax= 85.
         call newpex(ilatthi,ilatcol)
         call latlon(latmin,latmax,idlat,lonmin,lonmax,idlon,
     +	 hgttxt,xmin,xmax,ymin,ymax,xorigo,yorigo,xp,yp,jplon*jplat)
      endif
c  
      if(llogo)then
         call newpex(ilogthi,ilogcol)
         xlog=xmax-4.0
         ylog=ymin-1.25
         call logo(xlog,ylog,hgtlog)
      endif
c
      nsmut = 5
      ltype = 1
      mrkfrq = 1
      mrkdec = 0
      hgtmrk = 0.5*hgttxt
c
      call newpex(ifldthi,ifldcol)
c
      if( pplot ) then
c
	 zmin=900.
	 zmax=1500.
c
	 if(disop.lt.1) mrkdec = 1
	 call isolin(p,x,y,nlon,nlat,disop,zmin,zmax,nsmut,ltype,
     x			mrkfrq,mrkdec,hgtmrk,.true.,
     x			1,xmin,xmax,ymin,ymax,
     x			jplon*jplat,xp,yp,lin)
c
      else if( tplot ) then
c
	 zmin=-100.
	 zmax=+100.
c
	 if(disot.lt.1) mrkdec = 1
	 call isolin(t,x,y,nlon,nlat,disot,zmin,zmax,nsmut,ltype,
     x			mrkfrq,mrkdec,hgtmrk,.true.,
     x			1,xmin,xmax,ymin,ymax,
     x			jplon*jplat,xp,yp,lin)
c
      endif
c
      call obsar(tplot,pplot,nobs,ii,iii,lat,lon,
     x		       pobs,tobs,pflag,tflag,
     x		       obssize,xorigo,yorigo,xmin,xmax,ymin,ymax)

      call newpex(ifrathi,ifracol)
      if(lframe) then
         call framex(xmin,xmax,ymin,ymax)
         call framex(xmin,xmax,ymin-1.5,ymin)
      endif
c
      call endex
c      call system("ghostview -landscape POST")
c      call system("gs -landscape POST")
      stop

      end
