      subroutine latlon(latmin,latmax,idlat,
     x                  lonmin,lonmax,idlon,
     x                  hgtmrk,
     x                  xmin,xmax,ymin,ymax,
     x                  xorigo,yorigo,
     x                  xplot,yplot,maxvec)
c
      real latmin,latmax,idlat,lonmin,lonmax,idlon
      real hgtmrk,xmin,xmax,ymin,ymax,xorigo,yorigo
      integer maxvec
      real xplot(maxvec),yplot(maxvec)
c
#include "comrep.inc"
#include "comdef.inc"
#include "comlog.inc"

      logical bend
      real minlat,maxlat,lat,lon
      integer mrkdec
c
c**************************************************************************
c
      pi     = 4.*atan(1.)
      rearth = 6.371e+06
      zradi  = pi/180.
      eps = 1.e-3
      if( abs(idlon-float(int(idlon))).gt.eps .or.
     x    abs(idlat-float(int(idlat))).gt.eps ) then
         mrkdec = 2
      else
         mrkdec = 0
      endif
c
c******************************************************************************
c
c         map projection is polarstereographic
c
      if( maprep.eq.05 ) then
c
         zprola = prolat*zradi
         if( prolat.ge.0. ) then
            zrlen = ( 1. + sin(zprola))*rearth/(scale*1.e+6)*100.
         else
            zrlen = ( 1. - sin(zprola))*rearth/(scale*1.e+6)*100.
         endif
         zlatm  = latmid*zradi
         zlonm  = (lonmid-prolon)*zradi
         if( prolat.ge.0. ) then
            zrmid = zrlen*cos(zlatm)/(1.+sin(zlatm))
         else
            zrmid = zrlen*cos(zlatm)/(1.-sin(zlatm))
            zlonm = - zlonm
         endif
         zyor = - zrmid*cos(zlonm) - 0.5*dymap
         zxor =   zrmid*sin(zlonm) - 0.5*dxmap
c
         if( prolat.lt.0. ) then
            minlat = max(-90.,latmin)
            maxlat = min(20.,latmax)
         else
            minlat = max(-20.,latmin)
            maxlat = min(90.,latmax)
         endif
c
         zxadd = - zxor + 1.5e-5 + xorigo
         zyadd = - zyor + 1.5e-5 + yorigo
c
         do 120 lat=minlat,maxlat,idlat
         if( abs(lat).ge.90. ) goto 120
         np = 0
         do 110 lon=lonmin-idlon,lonmax+idlon,idlon
         if( lon.lt.-180. .or. lon.gt.180. ) goto 110
         np = np + 1
         zlat = lat*zradi
         zlon = (lon-prolon)*zradi
         if( prolat.gt.0. ) then
            zr = zrlen*cos(zlat)/(1.+sin(zlat))
         else
            zr = zrlen*cos(zlat)/(1.-sin(zlat))
            zlon = - zlon
         endif
         xplot(np) = zr*sin(zlon)  + zxadd
         yplot(np) = -zr*cos(zlon) + zyadd
  110    continue
         bend = .true.
         call llplot(maxvec,xplot,yplot,np,
     x          xmin,xmax,ymin,ymax,lat,mrkdec,hgtmrk,bend,'lat')
  120    continue
c
         do 140 lon=lonmin,lonmax,idlon
         np = 0
         if( prolat.lt.0. ) then
            minlat = max(-90.,latmin-idlat)
            maxlat = min(20.,latmax+idlat)
         else
            minlat = max(-20.,latmin-idlat)
            maxlat = min(90.,latmax+idlat)
         endif
         do 130 lat=minlat,maxlat,idlat
         if( lat.lt.-90. .or. lat.gt.90. ) goto 130
         np = np + 1
         zlat = lat*zradi
         zlon = (lon-prolon)*zradi
         if( prolat.gt.0. ) then
            zr = zrlen*cos(zlat)/(1.+sin(zlat))
         else
            zr = zrlen*cos(zlat)/(1.-sin(zlat))
            zlon = - zlon
         endif
         xplot(np) = zr*sin(zlon)  + zxadd
         yplot(np) = -zr*cos(zlon) + zyadd
  130    continue
         bend = .false.
         call llplot(maxvec,xplot,yplot,np,
     x          xmin,xmax,ymin,ymax,lon,mrkdec,hgtmrk,bend,'lon')
  140    continue
c
         return
c
c------------------------------------------------------------------------------
c
c         map projection is mercator
c
      else if( maprep.eq.01 ) then
c
         zprola = prolat*zradi
         zmult = rearth*cos(zprola)/(scale*1.e+6)*100.
         zlatm  = latmid*zradi
         zlonm  = lonmid*zradi
         zyor = zmult*alog( (1.+sin(zlatm))/cos(zlatm) ) - 0.5*dymap
         zxor = zmult*zlonm - 0.5*dxmap
         zxmx = zxor + dxmap
c
         minlat = max(-85.,latmin)
         maxlat = min(85.,latmax)
c
         zxadd = - zxor + 1.5e-5 + xorigo
         zyadd = - zyor + 1.5e-5 + yorigo
c
         do 160 lat=minlat,maxlat,idlat
         np = 0
         if( zxor/zmult/zradi.lt.lonmin ) then
            do 148 lon=lonmin-idlon,lonmax+idlon,idlon
            if( lon.lt.-180. .or. lon.gt.180. ) goto 148
            np = np + 1
            zlat = lat*zradi
            zlon = (lon-360)*zradi
            xplot(np) = zmult*zlon  + zxadd
            yplot(np) = zmult*alog( (1.+sin(zlat))/cos(zlat) ) + zyadd
  148       continue
         endif
         do 150 lon=lonmin-idlon,lonmax+idlon,idlon
         if( lon.lt.-180. .or. lon.gt.180. ) goto 150
         np = np + 1
         zlat = lat*zradi
         zlon = lon*zradi
         xplot(np) = zmult*zlon  + zxadd
         yplot(np) = zmult*alog( (1.+sin(zlat))/cos(zlat) ) + zyadd
  150    continue
         if( (zxor+dxmap)/zmult/zradi.gt.lonmax ) then
            do 152 lon=lonmin-idlon,lonmax+idlon,idlon
            if( lon.lt.-180. .or. lon.gt.180. ) goto 152
            np = np + 1
            zlat = lat*zradi
            zlon = (lon+360)*zradi
            xplot(np) = zmult*zlon  + zxadd
            yplot(np) = zmult*alog( (1.+sin(zlat))/cos(zlat) ) + zyadd
  152       continue
         endif
         bend = .false.
         call llplot(maxvec,xplot,yplot,np,
     x          xmin,xmax,ymin,ymax,lat,mrkdec,hgtmrk,bend,'lat')
  160    continue
c
         do 180 lon=lonmin,lonmax,idlon
         jlon = lon
         zx = zmult*zradi*jlon
         if( zx.lt.zxor ) then
            jlon = jlon + 360
         else if( zx.gt.zxmx ) then
            jlon = jlon - 360
         endif
         np = 0
         do 170 lat=minlat,maxlat,idlat
         np = np + 1
         zlat = lat*zradi
         zlon = jlon*zradi
         xplot(np) = zmult*zlon  + zxadd
         yplot(np) = zmult*alog( (1.+sin(zlat))/cos(zlat) ) + zyadd
  170    continue
         bend = .false.
         call llplot(maxvec,xplot,yplot,np,
     x          xmin,xmax,ymin,ymax,lon,mrkdec,hgtmrk,bend,'lon')
  180    continue
c
         return
c
c------------------------------------------------------------------------------
c
c         map projection is kulan
c
      else if( maprep.eq.30 ) then
c
         zmult = rearth/(scale*1.e+6)*100.
c
         zxadd = 0.5*dxmap + 1.5e-5 + xorigo
         zyadd = 0.5*dymap + 1.5e-5 + yorigo
c
         minlon = max(lonmin,-90.)
         maxlon = min(lonmax,90.)
c
         do 190 lat=latmin,latmax,idlat
         np = 0
         do 185 lon=minlon,maxlon,idlon
         np = np + 1
         zlat = lat*zradi
         zlon = lon*zradi
         zx = cos(zlat)*sin(zlon)
         zy = sin(zlat)
         xplot(np) = zmult*zx + zxadd
         yplot(np) = zmult*zy + zyadd
  185    continue
         bend = .false.
         call llplot(maxvec,xplot,yplot,np,
     x          xmin,xmax,ymin,ymax,lat,mrkdec,hgtmrk,bend,'lat')
  190    continue
c
         do 199 lon=minlon,maxlon,idlon
         np = 0
         do 197 lat=latmin,latmax,idlat
         np = np + 1
         zlat = lat*zradi
         zlon = lon*zradi
         zx = cos(zlat)*sin(zlon)
         zy = sin(zlat)
         xplot(np) = zmult*zx + zxadd
         yplot(np) = zmult*zy + zyadd
  197    continue
         bend = .true.
         call llplot(maxvec,xplot,yplot,np,
     x          xmin,xmax,ymin,ymax,lon,mrkdec,hgtmrk,bend,'lon')
  199    continue
c
         return
c
c------------------------------------------------------------------------------
c
c            map projection is regular lat/long
c
      else if( maprep.eq.00 ) then
c
         zfac = zradi*rearth/(scale*1.e+6)*100.0
         if( (irep.eq.0 .or.
     x        (irep.eq.10.and.alatnp.gt.89.9) ) .and. ltotal ) then
            zlomin = alonw
            zlomax = alone
            zlamin = alats
            zyadd = -zlamin*zfac + 1.e-5 + yorigo
            zxadd = -zlomin*zfac + 1.e-5 + xorigo
         else if( irep.eq.4 .and. ltotal) then
            zlomin = alonw
            zlomax = alone
            zlamin = gaulat(jsgaus)
            zyadd = -zlamin*zfac + 1.e-5 + yorigo
            zxadd = -zlomin*zfac + 1.e-5 + xorigo
         else
            zlomin = lonmid - 0.5*dxmap/zfac
            zlomax = lonmid + 0.5*dxmap/zfac
            zyor = latmid*zfac - 0.5*dymap
            zxor = lonmid*zfac - 0.5*dxmap
            zyadd = -zyor + 1.e-5 + yorigo
            zxadd = -zxor + 1.e-5 + xorigo
         endif
c
         do 220 lat=latmin,latmax,idlat
         if( abs(lat).ge.90. ) goto 220
         np = 0
c
         if( zlomin.lt. lonmin ) then
            zy = lat*zfac + zyadd
            do 208 lon=lonmin-idlon,lonmax+idlon,idlon
            if( lon.lt.-180. .or. lon.gt.180. ) goto 208
            np = np + 1
            xplot(np) = (lon-360)*zfac + zxadd
            yplot(np) = zy
  208       continue
         endif
c
         zy = lat*zfac + zyadd
         do 210 lon=lonmin-idlon,lonmax+idlon,idlon
         if( lon.lt.-180. .or. lon.gt.180. ) goto 210
         np = np + 1
         xplot(np) = lon*zfac + zxadd
         yplot(np) = zy
  210    continue
c
         if( zlomax.gt. lonmax ) then
            zy = lat*zfac + zyadd
            do 212 lon=lonmin-idlon,lonmax+idlon,idlon
            if( lon.lt.-180. .or. lon.gt.180. ) goto 212
            np = np + 1
            xplot(np) = (lon+360)*zfac + zxadd
            yplot(np) = zy
  212    continue
         endif
c
         bend = .false.
         call llplot(maxvec,xplot,yplot,np,
     x           xmin,xmax,ymin,ymax,lat,mrkdec,hgtmrk,bend,'lat')
  220    continue
c
         do 240 lon=lonmin,lonmax,idlon
         np = 0
         zx = lon*zfac + zxadd
         if( lon.lt.nint(zlomin) ) zx = zx + 360.*zfac
         if( lon.gt.nint(zlomax) ) zx = zx - 360.*zfac
         do 230 lat=latmin-idlat,latmax+idlat,idlat
         if( lat.lt.-90. .or. lat.gt.90. ) goto 230
         np = np + 1
         yplot(np) = lat*zfac + zyadd
         xplot(np) = zx
  230    continue
         bend = .false.
         call llplot(maxvec,xplot,yplot,np,
     x          xmin,xmax,ymin,ymax,lon,mrkdec,hgtmrk,bend,'lon')
  240    continue
c
         return
c
c------------------------------------------------------------------------------
c
c         map projection is lat/long with shifted pole
c
      else if( maprep.eq.10 ) then
c
            zfac = zradi*rearth/(scale*1.e+6)*100.0
            if( ltotal ) then
               zlomin = alonw
               zlamin = alats
            else
c              zlatm = fiprim(latmid,lonmid,alatnp)
c              zlonm = alampr(latmid,lonmid,alatnp)
               rlo= lonmid
	       rla= latmid
	       call regrot(rlo,rla,zlonm,zlatm,1,1,1,1,alonnp,alatnp,1)
               zlomin = zlonm - 0.5*dxmap/zfac
               zlamin = zlatm - 0.5*dymap/zfac
            endif
c
         zxadd = -zlomin*zfac + 1.e-5 + xorigo
         zyadd = -zlamin*zfac + 1.e-5 + yorigo
c
         do 320 lat=latmin,latmax,idlat
         if( abs(lat).ge.90. ) goto 320
         np = 0
         do 310 lon=lonmin-idlon,lonmax+idlon,idlon
         if( lon.lt.-180. .or. lon.gt.180. ) goto 310
         np = np + 1
c        zlat = fiprim(lat,lon,alatnp)
c        zlon = alampr(lat,lon,alatnp)
         rlo= lon
	 rla= lat
	 call regrot(rlo,rla,zlon,zlat,1,1,1,1,alonnp,alatnp,1)
         xplot(np) = zlon*zfac + zxadd
         yplot(np) = zlat*zfac + zyadd
  310    continue
         bend = .true.
         call llplot(maxvec,xplot,yplot,np,
     x          xmin,xmax,ymin,ymax,lat,mrkdec,hgtmrk,bend,'lat')
  320    continue
c
         do 340 lon=lonmin,lonmax,idlon
         np = 0
         do 330 lat=latmin,latmax,idlat
         if( lat.lt.-90. .or. lat.gt.90. ) goto 330
         np = np + 1
c        zlat = fiprim(lat,lon,alatnp)
c        zlon = alampr(lat,lon,alatnp)
         rlo= lon
	 rla= lat
	 call regrot(rlo,rla,zlon,zlat,1,1,1,1,alonnp,alatnp,1)
         xplot(np) = zlon*zfac + zxadd
         yplot(np) = zlat*zfac + zyadd
  330    continue
         bend = .true.
         call llplot(maxvec,xplot,yplot,np,
     x          xmin,xmax,ymin,ymax,lon,mrkdec,hgtmrk,bend,'lon')
  340    continue
c
         return
c
c------------------------------------------------------------------------------
c
c         map projection is rikets koordinater
c
      else if( maprep.eq.98 ) then
c
            zfac = 1./(scale*1.e+6)*100.0
            if( ltotal ) then
               zlomin = alonw
               zlamin = alats
            else
               call grerik(latmid,lonmid,zlamid,zlomid)
               zlomin = zlomid - 0.5*dxmap/zfac
               zlamin = zlamid - 0.5*dymap/zfac
            endif
c
         zxadd = -zlomin*zfac + 1.e-5 + xorigo
         zyadd = -zlamin*zfac + 1.e-5 + yorigo
c
         do 420 lat=latmin,latmax,idlat
         if( abs(lat).ge.90. ) goto 420
         np = 0
         do 410 lon=lonmin-idlon,lonmax+idlon,idlon
         if( lon.lt.-180. .or. lon.gt.180. ) goto 410
         np = np + 1
         call grerik(lat,lon,zlat,zlon)
         xplot(np) = zlon*zfac + zxadd
         yplot(np) = zlat*zfac + zyadd
  410    continue
         bend = .true.
         call llplot(maxvec,xplot,yplot,np,
     x          xmin,xmax,ymin,ymax,lat,mrkdec,hgtmrk,bend,'lat')
  420    continue
c
         do 440 lon=lonmin,lonmax,idlon
         np = 0
         do 430 lat=latmin-idlat,latmax+idlat,idlat
         if( lat.lt.-90. .or. lat.gt.90. ) goto 430
         np = np + 1
         call grerik(lat,lon,zlat,zlon)
         xplot(np) = zlon*zfac + zxadd
         yplot(np) = zlat*zfac + zyadd
  430    continue
         bend = .true.
         call llplot(maxvec,xplot,yplot,np,
     x          xmin,xmax,ymin,ymax,lon,mrkdec,hgtmrk,bend,'lon')
  440    continue
c
         return
c
c------------------------------------------------------------------------------

c         map projections not yet implemented
c
      else
c
            write(lulog,*)' lat/lon in proj ',maprep
            write(lulog,*)' not yet implemented!!!!!!!'
            stop
c
      endif
c
c****************************************************************************
c
      end

