c     +---------------------------------------------------+
c     + subroutine : guassian filter coefficients         +
c     +---------------------------------------------------+
      subroutine gfini(igcut,jgcut,g,
     +                   latm,dlat,dlon,clat,
     +                   sdevfg,gscale,lwin)
      implicit  none
      integer 	igcut,jgcut
      real 	latm,dlat,dlon,clat,sdevfg,gscale
      real 	g(-igcut:igcut,-jgcut:jgcut)
      real      gcut
      logical   lwin

      integer i,j
      real    clon,varian,ri,rj,dis2
      real    pi,x,y

      pi = asin(1.)*2.

      clon   = clat*cos(latm*pi/180.)

      varian = sdevfg*sdevfg
      do i=-igcut,igcut
      do j=-jgcut,jgcut
	 ri = i*dlon
	 rj = j*dlat
         dis2 =  ( (rj*clat)**2+(ri*clon)**2 )/gscale**2
         g(i,j) = varian*exp( -dis2 )
      enddo
      enddo

      if(lwin) then
         do i=-igcut,-1
         do j=-jgcut,jgcut
	    x=i*pi/(igcut+1)
	    g(i,j) = g(i,j) * sin(x)/x
         enddo
         enddo
         do i=     1,igcut
         do j=-jgcut,jgcut
	    x=i*pi/(igcut+1)
	    g(i,j) = g(i,j) * sin(x)/x
         enddo
         enddo
         do i=-igcut,igcut
         do j=-jgcut,-1
	    y=j*pi/(jgcut+1)
	    if(j.ne.0) g(i,j) = g(i,j) * sin(y)/y
         enddo
         enddo
         do i=-igcut,igcut
         do j=     1,jgcut
	    y=j*pi/(jgcut+1)
	    if(j.ne.0) g(i,j) = g(i,j) * sin(y)/y
         enddo
         enddo
      endif

      write(6,*) 'filter coefficients'
      do i=-igcut,igcut
	 write(6,*) i,g(i,0)
      enddo

      end
